"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
/**
 * Created by Tien Nguyen on 11/29/16.
 */
/**
 *
 * @param objectBody
 * @param keyChange
 * @param changeOption
 * @returns {*}
 */
function getValueChangeOption(objectBody, keyChange, changeOption) {
    var value = objectBody[keyChange] ? objectBody[keyChange] : changeOption.$default;
    if (changeOption.$get) {
        return value;
    }
    if (changeOption.$update) {
        return changeOption.$update(value);
    }
    if (changeOption.$set) {
        return changeOption.$set;
    }
}

/**
 * Parse body Object to data Object
 * @param objectBody
 * @param objectChange
 * @returns {{}}
 */
function convertData(objectBody, objectChange) {
    var keysChange = Object.keys(objectChange);
    var objectReturn = {};
    keysChange.map(function (keyChange) {
        var changeOption = objectChange[keyChange];
        objectReturn[keyChange] = getValueChangeOption(objectBody, keyChange, changeOption);
        return keyChange;
    });
    return objectReturn;
}

exports.convertData = convertData;